openapi: "3.0.0"
info:
  version: 1.0.0
  title: Demo Petstore Client
servers:
  - url: http://localhost:8080
paths:
  /pets:
    get:
      summary: List all pets
      operationId: listPets
      tags:
        - pets
      security: 
        - authPets: 
          - api
      responses:
        '200':
          description: A paged array of pets
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/Pets"
    post:
      summary: Create a pet
      operationId: createPets
      tags:
        - pets
      security: 
        - authPets: 
          - api
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/Pet"
      responses:
        '201':
          description: Pet response
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/Pet"
components:
  securitySchemes:
    authPets:
      type: oauth2
      flows:
        password:
          tokenUrl: /oauth/token
          scopes:
            api: rest scope
      
  schemas:
    Pet:
      type: object
      required:
        - id
        - name
        - type
      properties:
        id:
          type: integer
          format: int64
        name:
          type: string
        type:
          $ref: '#/components/schemas/PetType'
    PetType:
      type: object
      required:
        - name
      properties:
        name:
          type: string
    Pets:
      type: array
      items:
        $ref: "#/components/schemas/Pet"
    Types:
      type: array
      items:
        $ref: "#/components/schemas/PetType"
